/// FOURJS_START_COPYRIGHT(D,2015)
/// Property of Four Js*
/// (c) Copyright Four Js 2015, 2019. All Rights Reserved.
/// * Trademark of Four Js Development Tools Europe Ltd
///   in the United States and elsewhere
/// 
/// This file can be modified by licensees according to the
/// product manual.
/// FOURJS_END_COPYRIGHT

"use strict";

modulum('MyMainContainerWidget', ['MainContainerWidget', 'WidgetFactory'],
  function(context, cls) {

    cls.MyMainContainerWidget = context.oo.Class(cls.MainContainerWidget, function($super) {
      return {
        __name: "MyMainContainerWidget",

        _model: null,

        _appsCount: null,

        constructor: function(opts) {
          $super.constructor.call(this, opts);
          
          this._appsCount = 0;
          this._model = new cls.ModelHelper(this);
          this._model.addNewApplicationListener(this.onNewApplication.bind(this));
          this._model.addCloseApplicationListener(this.onCloseApplication.bind(this));
        },
        
        getAppsCount: function() {
          return this._appsCount;
        },

        onNewApplication: function(application) {
          ++this._appsCount;
        },

        onCloseApplication: function(application) {
          --this._appsCount;
        }
      };
    });

    cls.WidgetFactory.registerBuilder('MainContainer', cls.MyMainContainerWidget);
  });
